/*
  pinmode.h - GPIO Pin Mode

  Copyright (c) 2022 Sasapea's Lab. All right reserved.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General
  Public License along with this library; if not, write to the
  Free Software Foundation, Inc., 59 Temple Place, Suite 330,
  Boston, MA  02111-1307  USA
*/
#pragma once

#include <stdint.h>
#include <stdbool.h>

typedef enum
{
  INPUT       = 0,
  OUTPUT      = 1,
  OPEN_DRAIN  = 2,
  OPEN_SOURCE = 3,
} PinMode;

typedef enum
{
  PULL_DISABLE = 0,
  PULL_UP      = 1,
  PULL_DOWN    = 2,
} PinPull;

typedef enum
{
  CHANGE  = 0,
  RISING  = 1,
  FALLING = 2,
} PinEdge;

typedef enum
{
  LOW  = 0,
  HIGH = 1,
} PinStatus;

typedef uint32_t pin_size_t;
