#include <stdio.h>
#include "pinctrl.h"
#include <unistd.h>

#define PIN 19
//#define PIN 65

void callback(void *arg, const struct gpio_v2_line_event& event)
{
  const char *msg = "?";
  switch (event.id)
  {
    case GPIO_V2_LINE_EVENT_RISING_EDGE:  msg = "RISING_EDGE";  break;
    case GPIO_V2_LINE_EVENT_FALLING_EDGE: msg = "FALLING_EDGE"; break;
  }
  printf("line %u: %s at %lu\n", event.offset, msg, event.timestamp_ns);
}

int main(int argc, char **argv)
{
  if (GPIO.begin() == 0)
    printf("Error: begin()\n");
  else
  {
    for (size_t i = 0;; ++i)
    {
      const struct gpiochip_info *info = GPIO.chip_info(i);
      if (!info)
        break;
      printf("name: %s, label: %s, lines: %u\n", info->name, info->label, info->lines);
    }
    GPIO.pinMode(PIN, OUTPUT);
    //GPIO.attachInterruptParam(PIN, callback, NULL, CHANGE, PULL_UP, 10000);
    while (1)
    {
      printf("digitalRead(%d)=%d\n", PIN, GPIO.digitalRead(PIN));
      GPIO.digitalWrite(PIN, GPIO.digitalRead(PIN) ? LOW : HIGH);
      GPIO.sleep(1000);
      //GPIO.digitalWrite(PIN, HIGH);
      //printf("digitalRead(%d)=%d\n", PIN, GPIO.digitalRead(PIN));
      //GPIO.digitalWrite(PIN, LOW);
    }
    GPIO.end();
  }
  return 0;
}
